
source('per.cmd')
source('bp.cmd')

set.seed(291)
rowcut_.9*nrow(alliris)
tstrowcut_nrow(alliris)-rowcut
colcut_5
dyn.load2(c("bp.o","perceptron.o"),userlibs="", ,size=100000)

for(itrial in 1:10)
{
#
#create training data
#
indi_sample(nrow(alliris),rowcut)
preds_matrix(alliris[indi,2:colcut],ncol=colcut-1,nrow=rowcut)
resps_matrix(alliris[indi,1],ncol=1,nrow=rowcut)

mtrn_apply(preds,2,mean)
vtrn_apply(preds,2,var)
preds_sweep(preds,2,mtrn)
preds_sweep(preds,2,FUN="/",sqrt(vtrn))
#
#tree train
#
ttrn_data.frame(resps,preds)
ttime_unix.time(treetrn_tree(ttrn))
#
###
#
#back propagation bench train
#
#dyn.load2("bp.o",userlibs="", ,size=100000)
bptime_unix.time(segtrn_bptrain(preds,resps,acceptable.error.rate=.05))

###
#
# perceptron bench
#
#train
#
#dyn.load2("perceptron.o",userlibs="", ,size=100000)
ptime_unix.time(psegtrn_perceptron.train(preds,resps,acceptable.error.rate=.05,learning.rate=.1))
#

########################################################
########################################################
########################################################
#
#create test data
#
# z out the test data using the mean and sd from
# the training data.
#
preds_matrix(alliris[-indi,2:colcut],ncol=colcut-1,nrow=tstrowcut)
resps_matrix(alliris[-indi,1],ncol=1,nrow=tstrowcut)
preds_sweep(preds,2,mtrn)
preds_sweep(preds,2,FUN="/",sqrt(vtrn))
rm(mtrn)
rm(vtrn)


# tree test
#
ttst_data.frame(resps,preds)
treetst_predict.tree( treetrn,ttst)
treetst_round(treetst)
z_treetst-resps
misses_(length(z[z!=0]))
print(c("t",itrial,misses,length(z),ttime))
rm(treetst)
rm(treetrn)

#back propagation test
#
segtst_bptest( preds,resps,segtrn)
z_segtst$tst.guessed.class-segtst$tst.adj.class
misses_length(z[z!=0])
print(c("b",itrial,misses,length(z),bptime))
rm(segtst)
rm(segtrn)

#perceptron test
#
psegtst_perceptron.test( preds,resps,psegtrn)
z_psegtst$tst.guessed.class-psegtst$tst.adj.class
misses_length(z[z!=0])
print(c("p",itrial,misses,length(z),ptime))
rm(psegtst)
rm(psegtrn)

rm(z)
rm(ptime)
rm(misses)
rm(ttst)
rm(preds)
rm(resps)

}# end of loop on itrial 

